/**********************************************************/
/** Done by  |      Date     |  version |    comment     **/
/**------------------------------------------------------**/
/**   CEV    |    05-2016    |   1.0    |  creation/SDL1 **/
/**********************************************************/

#ifndef GIFUSER_H_INCLUDED
#define GIFUSER_H_INCLUDED

#include <SDL.h>
#include "CEV_gifToSurface.h"

#define GIF_ALL        -1
#define GIF_REPEAT_FOR 0
#define GIF_ONCE_FOR   1
#define GIF_FORTH_BACK 2
#define GIF_REPEAT_REV 3
#define GIF_ONCE_REV   4
#define GIF_STOP       5

#define GIF_FORWARD     0
#define GIF_BACKWARD    1

#define VERB 0

#ifdef __cplusplus
extern "C" {
#endif

enum{GIF_FATAL =-2, GIF_ERR =-1, GIF_OK =0};

/**direct gif animation load from gif file*/
CEV_GifAnim * CEV_gifAnimLoad(const char*);

/**gif animation load from SDL_RWops */
CEV_GifAnim * CEV_gifAnimLoadRW(SDL_RWops*, char freeSrc);

/**returns embedded comment*/
char *CEV_gifComment(CEV_GifAnim*);

/**returns embedded version*/
char *CEV_gifVersion(CEV_GifAnim*);

/**returns embedded signature*/
char *CEV_gifSignature(CEV_GifAnim*);

/**returns User's surface**/
SDL_Surface *CEV_gifSurface(CEV_GifAnim*);

/**returns num of pics*/
int CEV_gifFrameNum(CEV_GifAnim *anim);

/**forces next frame*/
void CEV_gifFrameNext(CEV_GifAnim*);

/**sets animation speed*/
void CEV_gifSpeedSet(CEV_GifAnim*, int , int );

/**sets loop reading mode*/
void CEV_gifLoopMode(CEV_GifAnim*, unsigned int );

/**resets loop animation**/
void CEV_gifLoopReset(CEV_GifAnim*);

/**updates animations**/
char CEV_gifAnimAuto(CEV_GifAnim*);

/**reverses play mode*/
void CEV_gifReverse(CEV_GifAnim*);

/**frees animation structure**/
void CEV_gifAnimFree(CEV_GifAnim*);

/**returns if loop is playing or not**/
char CEV_gifLoopStatus(CEV_GifAnim*);

/**returns used method**/
char CEV_gifMethod(CEV_GifAnim*, uint8_t);

/**sets method**/
void CEV_gifMethodSet(CEV_GifAnim*, int, uint8_t);

#ifdef __cplusplus
}
#endif

#endif /* GIFUSER_H_INCLUDED */
