/**********************************************************/
/** Done by  |      Date     |  version |    comment     **/
/**------------------------------------------------------**/
/**   CEV    |    05-2016    |   1.0    |  creation/SDL1 **/
/**********************************************************/

#ifndef GIFTOSURFACE_H_INCLUDED
#define GIFTOSURFACE_H_INCLUDED

#include <SDL.h>
#include "CEV_gifDeflate.h"

#define METHOD_OVERWRITE 1
#define METHOD_REDRAW 2

#ifdef __cplusplus
extern "C" {
#endif


typedef struct
{
    uint8_t dispMethod,
            *pixels;

    uint16_t time;

    SDL_Rect pos;
}
L_GifFrame;/*local*/


typedef struct
{
    SDL_Rect pos;
    SDL_Surface * surface;
}
L_GifSurfaceMain;


typedef struct
{
    char *comment,
         signature[4],
         version[4],
         loopDone,
         direction,
         refresh;

    uint8_t loopMode;
    unsigned int time,
                timeAct;
    int         imgNum,
                imgAct;

}L_GifInfo;


typedef struct
{
    L_GifInfo status;
    L_GifSurfaceMain display;
    L_GifFrame *pictures;
}
CEV_GifAnim;


void L_gifFillSurface(uint8_t *pixels, L_GifFile* gif, int index);

void L_gifFillSurfaceInterlace(uint8_t *pixels, L_GifFile* gif, int index);

int L_gifColorToInt(L_GifColor color, L_GifColorShift*);

void CEV_FillWithAlpha(const uint8_t*, const SDL_Rect* , SDL_Surface*);

void CEV_GifBlitSurface(const uint8_t*, const SDL_Rect* , SDL_Surface*);

char L_gifPtIsInBox(int , int , const SDL_Rect*);

char L_gifBlit(CEV_GifAnim *anim);

void L_gifPicSelectNxt(CEV_GifAnim *anim);

char L_gifAddModulo(int mode,int* val,int num);

char L_gifAddLim(int mode, int *val, int num);

void L_gifFitBoxInto(SDL_Rect*, const SDL_Rect*);

char L_gifAnimInit(CEV_GifAnim*, L_GifFile*);

#ifdef __cplusplus
}
#endif

#endif /* GIFTOSURFACE_H_INCLUDED*/
